DELIMITER ??
DROP PROCEDURE IF EXISTS addfield??
CREATE PROCEDURE addfield()
BEGIN

#1tb_chrommedmain---InstrumentGuidchar36, not null
  	IF NOT EXISTS (SELECT * FROM information_schema.columns 
  	WHERE table_schema = DATABASE()  AND table_name = 'tb_chrommedmain' AND column_name = 'InstrumentGuid') THEN
	alter table tb_chrommedmain add InstrumentGuid  char(36) NOT NULL AFTER Name; 
	END IF;

#2tb_taskmedmain---InstrumentGuidchar36, not null
  	IF NOT EXISTS (SELECT * FROM information_schema.columns 
  	WHERE table_schema = DATABASE()  AND table_name = 'tb_taskmedmain' AND column_name = 'InstrumentGuid') THEN
	alter table tb_taskmedmain add InstrumentGuid  char(36) NOT NULL AFTER Name; 
	END IF;

#3tb_calibratecompoundinfoquantify---BEraseEmptyint1, not null
  	IF NOT EXISTS (SELECT * FROM information_schema.columns 
  	WHERE table_schema = DATABASE()  AND table_name = 'tb_calibratecompoundinfoquantify' AND column_name = 'BEraseEmpty') THEN
	alter table tb_calibratecompoundinfoquantify add BEraseEmpty  int(1) default 0 NOT NULL; 
	END IF;

#4tb_calibratecompoundinfo---k3double0, not null
  	IF NOT EXISTS (SELECT * FROM information_schema.columns 
  	WHERE table_schema = DATABASE()  AND table_name = 'tb_calibratecompoundinfo' AND column_name = 'k3') THEN
	alter table tb_calibratecompoundinfo add k3 double default 0 NOT NULL; 
	END IF;


#5tb_chromatogramext
  IF EXISTS (SELECT * FROM information_schema.columns 
    WHERE table_schema = DATABASE()  AND table_name = 'tb_chromatogramext' AND column_name = 'RangeMax') THEN
  alter table tb_chromatogramext modify column RangeMax double; alter table tb_chromatogramext modify column RangeMin double;
  END IF;

#6tb_chromatogramext---CalcStdint0, not null
	IF NOT EXISTS (SELECT * FROM information_schema.columns 
  	WHERE table_schema = DATABASE()  AND table_name = 'tb_chromatogramext' AND column_name = 'CalcStd') THEN
	alter table tb_chromatogramext add CalcStd int(1) default 0 NOT NULL; 
	END IF;

#7tb_calibratechrompeakunknow---YUnit
	alter table tb_calibratechrompeakunknow modify column YUnit varchar(255) CHARACTER SET gbk NOT NULL;
	alter table tb_calibratechrompeakunknow modify column XUnit varchar(255) CHARACTER SET gbk NOT NULL;

#8tb_moduledevice---GroupIDint0, not nullgroupName
	IF NOT EXISTS (SELECT * FROM information_schema.columns 
  	WHERE table_schema = DATABASE()  AND table_name = 'tb_moduledevice' AND column_name = 'GroupID') THEN
	alter table tb_moduledevice add DevNo int(11) default 0 NOT NULL; 
	alter table tb_moduledevice add GroupID int(11) default 0 NOT NULL; 
	alter table tb_moduledevice add GroupName varchar(255) NOT NULL; 
	END IF;

#9tb_chromatogram---bDelint0, not null
	IF NOT EXISTS (SELECT * FROM information_schema.columns 
  	WHERE table_schema = DATABASE()  AND table_name = 'tb_chromatogram' AND column_name = 'bDel') THEN
	alter table tb_chromatogram add bDel int(1) default 0 NOT NULL; 
	END IF;

#10tb_seq---InstrumentGuidchar36, not null
	IF NOT EXISTS (SELECT * FROM information_schema.columns 
  	WHERE table_schema = DATABASE()  AND table_name = 'tb_seq' AND column_name = 'InstrumentGuid') THEN
	alter table tb_seq add InstrumentGuid char(36) NOT NULL; 
    	update tb_seq q INNER JOIN tb_project p on q.ProjectGuid = p.Guid set q.InstrumentGuid = p.InstrumentGuid;
	UPDATE tb_seq set ProjectGuid = '11111111-1111-1111-1111-111111111111';
	END IF;

#11tb_task---Massicdouble1, not null)
	IF NOT EXISTS (SELECT * FROM information_schema.columns 
  	WHERE table_schema = DATABASE()  AND table_name = 'tb_task' AND column_name = 'Massic') THEN
	alter table tb_task add Massic double default 1 NOT NULL; 
	alter table tb_task add Dilute double default 1 NOT NULL;
	END IF;

#12tb_task---MateVoldouble1, not null)
	IF NOT EXISTS (SELECT * FROM information_schema.columns 
  	WHERE table_schema = DATABASE()  AND table_name = 'tb_task' AND column_name = 'MateVol') THEN
	alter table tb_task add MateVol double default 1 NOT NULL; 
	alter table tb_chromatogram add MateVol double default 1 NOT NULL; 
	END IF;

#13tb_printtemplateheader---bPrintFooterint1, not null)
	IF NOT EXISTS (SELECT * FROM information_schema.columns 
  	WHERE table_schema = DATABASE()  AND table_name = 'tb_printtemplateheader' AND column_name = 'bPrintFooter') THEN
	alter table tb_printtemplateheader add bPrintFooter int(1) default 1 NOT NULL; 
	END IF;

#14tb_chromatogram---SampleIDvarchar255, not null
	IF NOT EXISTS (SELECT * FROM information_schema.columns 
  	WHERE table_schema = DATABASE()  AND table_name = 'tb_chromatogram' AND column_name = 'SampleID') THEN
	alter table tb_chromatogram add SampleID varchar(255) CHARACTER SET gbk NOT NULL; 
	END IF;

#15tb_printtemplateheader---FooterModeint1, not null)
	IF NOT EXISTS (SELECT * FROM information_schema.columns 
  	WHERE table_schema = DATABASE()  AND table_name = 'tb_printtemplateheader' AND column_name = 'FooterMode') THEN
	alter table tb_printtemplateheader add FooterMode int(1) default 0 NOT NULL; 
	alter table tb_printtemplateheader add FooterText varchar(255) CHARACTER SET gbk NOT NULL; 
	END IF;

END??


DROP PROCEDURE IF EXISTS addtables??
CREATE PROCEDURE addtables()
BEGIN

#1tb_chromatogramext

    IF NOT EXISTS (SELECT * FROM information_schema.columns 
    WHERE table_schema = DATABASE()  AND table_name = 'tb_chromatogramext') THEN
    CREATE TABLE `tb_chromatogramext` (
  `ChromGuid` char(36) NOT NULL,
  `RangeMax` double  NOT NULL,
  `RangeMin` double  NOT NULL,
  `CalcStd` int(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ChromGuid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

  END IF;

#2tb_moduledeviceproxy
IF NOT EXISTS (SELECT * FROM information_schema.columns 
    WHERE table_schema = DATABASE()  AND table_name = 'tb_moduledeviceproxy') THEN
    CREATE TABLE `tb_moduledeviceproxy` (
  `DeviceGuid` char(36) NOT NULL,
  `Name` varchar(255) NOT NULL,
  `Type` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

  END IF;

#3tb_devicesource
IF NOT EXISTS (SELECT * FROM information_schema.columns 
    WHERE table_schema = DATABASE()  AND table_name = 'tb_devicesource') THEN
    CREATE TABLE `tb_devicesource` (
  `Guid` char(36) NOT NULL,
  `Name` varchar(255) NOT NULL,
  `ModuleGuid` char(36) NOT NULL,
  `Type` int(11) NOT NULL,
  `ConnType` int(11) NOT NULL DEFAULT '0' COMMENT '0, COM;1,TCP',
  `Count` int(11) NOT NULL,
  PRIMARY KEY (`Guid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

  END IF;

#4tb_devicesourceproxy
IF NOT EXISTS (SELECT * FROM information_schema.columns 
    WHERE table_schema = DATABASE()  AND table_name = 'tb_devicesourceproxy') THEN
    CREATE TABLE `tb_devicesourceproxy` (
  `DeviceGuid` char(36) NOT NULL,
  `Name` varchar(255) NOT NULL,
  `Type` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

  END IF;

#5tb_deviceproxy
IF NOT EXISTS (SELECT * FROM information_schema.columns 
    WHERE table_schema = DATABASE()  AND table_name = 'tb_deviceproxy') THEN
    CREATE TABLE `tb_deviceproxy` (
  `InstrumentGuid` char(36) NOT NULL,
  `SourceGuid` char(36) NOT NULL,
  `ModuleGuid` char(36) NOT NULL,
  `Guid` char(36) NOT NULL,
  `Name` varchar(255) CHARACTER SET gbk NOT NULL,
  `Proxy` int(11) NOT NULL DEFAULT '0' COMMENT '0, COM;1,TCP',
  PRIMARY KEY (`Guid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

  END IF;

#6tb_subdevicemeduserprog
IF NOT EXISTS (SELECT * FROM information_schema.columns 
    WHERE table_schema = DATABASE()  AND table_name = 'tb_subdevicemeduserprog') THEN
    CREATE TABLE `tb_subdevicemeduserprog` (
  `AnalyseGuid` char(36) NOT NULL,
  `ModuleGuid` char(36) NOT NULL,
  `Module` varchar(255) NOT NULL,
  `VarName` varchar(255) DEFAULT NULL,
  `Value` varchar(255) DEFAULT NULL,
  `Index` int(11) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

  END IF;

#7tb_taskmeduserprog
IF NOT EXISTS (SELECT * FROM information_schema.columns 
    WHERE table_schema = DATABASE()  AND table_name = 'tb_taskmeduserprog') THEN
    CREATE TABLE `tb_taskmeduserprog` (
  `TaskGuid` char(36) NOT NULL,
  `AnalyseGuid` char(36) NOT NULL,
  `ModuleGuid` char(36) NOT NULL,
  `Module` varchar(255) NOT NULL,
  `VarName` varchar(255) DEFAULT NULL,
  `Value` varchar(255) DEFAULT NULL,
  `Index` int(11) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

  END IF;

#8tb_chrommeduserprog
IF NOT EXISTS (SELECT * FROM information_schema.columns 
    WHERE table_schema = DATABASE()  AND table_name = 'tb_chrommeduserprog') THEN
    CREATE TABLE `tb_chrommeduserprog` (
  `ChromGuid` char(36) NOT NULL,
  `AnalyseGuid` char(36) NOT NULL,
  `ModuleGuid` char(36) NOT NULL,
  `Module` varchar(255) NOT NULL,
  `VarName` varchar(255) DEFAULT NULL,
  `Value` varchar(255) DEFAULT NULL,
  `Index` int(11) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

  END IF;

#9tb_projectNew
IF NOT EXISTS (SELECT * FROM information_schema.columns 
    WHERE table_schema = DATABASE()  AND table_name = 'tb_projectNew') THEN
    CREATE TABLE `tb_projectnew` (
  `ID` int NOT NULL AUTO_INCREMENT,
  `Guid` char(36) NOT NULL,
  `Name` varchar(255) CHARACTER SET gbk COLLATE gbk_chinese_ci NOT NULL,
  `bDel` int NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`Guid`),
  UNIQUE KEY `Uni_ProjectGuid` (`Guid`)
) ENGINE=MyISAM AUTO_INCREMENT=86 DEFAULT CHARSET=latin1;
    INSERT INTO `tb_projectnew` VALUES ('1', '11111111-1111-1111-1111-111111111111', 'default', '0');

  END IF;

END??

DROP PROCEDURE IF EXISTS updatefield??
CREATE PROCEDURE updatefield()
BEGIN
ALTER TABLE tb_subdevicemed MODIFY COLUMN value varchar(1000);
ALTER TABLE tb_taskmed MODIFY COLUMN value varchar(1000);
ALTER TABLE tb_chrommed MODIFY COLUMN value varchar(1000);
ALTER TABLE tb_task MODIFY COLUMN SampleID varchar(255) CHARACTER SET gbk NOT NULL; 
ALTER TABLE tb_task MODIFY COLUMN ChromName varchar(255) CHARACTER SET gbk NOT NULL; 

END??

CALL addtables()??
CALL addfield()??
CALL updatefield()??
CALL addfield()??

DELIMITER ;





